###Sets up scoreboards for advancements and attacks. Utilizes same objectives as nitk for resources###
scoreboard objectives add nitWarCraft dummy
scoreboard objectives add nitHellAttacks dummy
scoreboard objectives add nitBoxProg dummy
scoreboard objectives add nitKeepCraft dummy
advancement grant @a[advancements={nitk:nitk/ach4.1=true},nbt={Dimension:"minecraft:the_nether"}] only nitco:nitco/root

###Create the portal###
setblock ~ ~ ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:-7,mode:"LOAD",posY:-5,sizeX:15,posZ:-7,integrity:1.0f,name:"nitco:portal",sizeY:16,sizeZ:15} replace
setblock ~ ~1 ~ minecraft:redstone_block
tp @s[tag=!global.ignore.pos] ~ ~1 ~
fill ~-2 ~-6 ~-2 ~2 ~-6 ~2 minecraft:repeating_command_block{auto:1,Command:"fill ~ ~ ~ ~ 20 ~ nether_bricks"}

###Place siteplanner to the east###
setblock ~7 ~1 ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitco:siteplanner_e",sizeY:2,sizeZ:1} replace
setblock ~7 ~2 ~ minecraft:redstone_block

###Place siteplanner to the west###
setblock ~-7 ~1 ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitco:siteplanner_w",sizeY:2,sizeZ:1} replace
setblock ~-7 ~2 ~ minecraft:redstone_block

###Place siteplanner to the north###
setblock ~ ~1 ~-7 minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitco:siteplanner_n",sizeY:2,sizeZ:1} replace
setblock ~ ~2 ~-7 minecraft:redstone_block

###Place siteplanner to the south###
setblock ~ ~1 ~7 minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitco:siteplanner_s",sizeY:2,sizeZ:1} replace
setblock ~ ~2 ~7 minecraft:redstone_block

###Remove the strategy###
clear @p written_book{title:"War Strategy"}

###Adds forceload to ensure structure generation###
forceload add ~-100 ~-100 ~100 ~100

###Assigns the fortress' ID###
execute store result score @s nitID run data get entity @s UUID[0]
scoreboard players operation @e[tag=nitNetherbrickStor,limit=1,sort=nearest] nitID = @s nitID
scoreboard players operation @e[tag=nitCGoldStor,limit=1,sort=nearest] nitID = @s nitID
tag @s add nitDenizen

###Summons markers for natural structures###
summon minecraft:marker ~ 128 ~ {Tags:[nitEntity,nitEntityTechnical,nitSpreadCenter,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellShip,nitCSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellFactory,nitCSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellDrill,nitCSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitWithermaw,nitCSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitBoxCenter,nitCSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
scoreboard players operation @e[tag=nitCSpecialFeature,limit=4,sort=nearest] nitID = @s nitID

###Spreads the natural structures for the matching fortress###
scoreboard players operation #nitID nitTemp = @s nitID
execute as @e[tag=nitCSpecialFeature,limit=4,sort=nearest] if score @s nitID = #nitID nitTemp run tag @s add nitID_match
execute as @e[tag=nitSpreadCenter] at @e[tag=nitSpreadCenter] run function nitco:spread_features
kill @e[tag=nitSpreadCenter]

###Builds natural structures###
execute as @e[tag=nitHellShip,tag=nitID_match] at @s run function nitco:special/gen_ship
execute as @e[tag=nitHellFactory,tag=nitID_match] at @s run function nitco:special/gen_factory
execute as @e[tag=nitHellDrill,tag=nitID_match] at @s run function nitco:special/gen_drill
execute as @e[tag=nitWithermaw,tag=nitID_match] at @s run function nitco:special/gen_withermaw
execute as @e[tag=nitBoxCenter,tag=nitID_match] at @s run function nitco:special/paradox_box/boxinit
tag @e[tag=nitCSpecialFeature,tag=nitID_match] remove nitID_match

###Summons the War Strategist, who fulfills similar function to Town Planner###
execute at @e[tag=nitWarStrategist] as @s run summon villager ~ ~ ~ {VillagerData:{profession:weaponsmith,level:5,type:swamp},Invulnerable:1,PersistenceRequired:1,NoAI:1,CustomName:"\"War Strategist\"",Offers:{Recipes:[{buy:{id:feather,Count:1},sell:{id:"minecraft:written_book",Count:1},maxUses:9999999},{buy:{id:firework_star,Count:1,tag:{HideFlags:1,display:{Name:'{"text":"Tyrannical Heart"}'},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},sell:{id:gold_ingot,Count:3},maxUses:9999999},{buy:{id:firework_star,Count:5,tag:{HideFlags:1,display:{Name:'{"text":"Tyrannical Heart"}'},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},sell:{id:compass,Count:1,tag:{nitco_compass:1b,HideFlags:1,display:{Name:'{"text":"Tyranny Spotter"}',Lore:['{"text":"Points to the Tyrant\'s"}','{"text":"nearest active base"}','{"text":"with a magical flame."}']},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},maxUses:9999999},{buy:{id:gold_ingot,Count:16},sell:{id:ender_eye,Count:1},maxUses:9999999}]},Tags:[nitDenizen,nitCWS,nitEntity,global.ignore]}
scoreboard players operation @e[tag=nitCWS,limit=1,sort=nearest] nitID = @s nitID
function nitk:debug/update_all
kill @e[tag=nitWarStrategist]

###Anounces completed process###
forceload remove ~-100 ~-100 ~100 ~100
tellraw @s [{"text":"[۩]","color":"green","bold":true},{"text":": ","color":"white","bold":false},{"text":"You have successfully launched your Counteroffensive!","color":"white","bold":false}]