gamerule commandBlockOutput false

###Sets scoreboards used for advancements, attacks, and resource spawning###
scoreboard objectives add nitSiteCraft dummy
scoreboard objectives add nitCastleCraft dummy
scoreboard objectives add nitHellAttacks dummy
scoreboard objectives add nitResourceTime dummy
scoreboard objectives add nitResourceSpawn dummy
scoreboard objectives add nitTaxSpawn dummy
scoreboard objectives add nitID dummy
scoreboard objectives add nitTemp dummy
scoreboard objectives add nitSpreadLim dummy
scoreboard objectives add nitLightType dummy
scoreboard objectives add nitPostType dummy
scoreboard objectives add nitRaidProg dummy

###Create the settler wagon###
setblock ~ ~ ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:-7,mode:"LOAD",posY:-3,sizeX:15,posZ:-7,integrity:1.0f,name:"nitk:wagon",sizeY:32,sizeZ:15} replace
setblock ~ ~1 ~ minecraft:redstone_block
tp @s[tag=!global.ignore.pos] ~ ~2 ~

###Place siteplanner to the east###
setblock ~7 ~ ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitk:siteplanner_e",sizeY:2,sizeZ:1} replace
setblock ~7 ~1 ~ minecraft:redstone_block

###Place siteplanner to the west###
setblock ~-7 ~ ~ minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitk:siteplanner_w",sizeY:2,sizeZ:1} replace
setblock ~-7 ~1 ~ minecraft:redstone_block

###Place siteplanner to the north###
setblock ~ ~ ~-7 minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitk:siteplanner_n",sizeY:2,sizeZ:1} replace
setblock ~ ~1 ~-7 minecraft:redstone_block

###Place siteplanner to the south###
setblock ~ ~ ~7 minecraft:structure_block{ignoreEntities:0b,rotation:"NONE",posX:0,mode:"LOAD",posY:0,sizeX:1,posZ:0,integrity:1.0f,name:"nitk:siteplanner_s",sizeY:2,sizeZ:1} replace
setblock ~ ~1 ~7 minecraft:redstone_block

###Remove the charter###
clear @p written_book{title:"Town Charter"}

###Assigns the town's ID###
tag @a[distance=..20] add nitCitizen
execute store result score @s nitID run data get entity @s UUID[0]
scoreboard players operation @e[tag=nitStoneStor,limit=1,sort=nearest] nitID = @s nitID
scoreboard players operation @e[tag=nitLumberStor,limit=1,sort=nearest] nitID = @s nitID

###Assigns wagon color###
function nitk:wagon_color

###Adds forceload to ensure structure generation###
forceload add ~-100 ~-100 ~100 ~100

###Summons markers for hell attacks###
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite1,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite2,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite3,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite4,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite5,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHellSite6,nitHellSite,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
scoreboard players operation @e[tag=nitHellSite,limit=6,sort=nearest] nitID = @s nitID
scoreboard players set @e[tag=nitHellSite,limit=6,sort=nearest] nitHellAttacks 0

###Spreads the hell attack markers for this town###
scoreboard players operation #nitID nitTemp = @s nitID
execute as @e[tag=nitHellSite,limit=6,sort=nearest] if score @s nitID = #nitID nitTemp run tag @s add nitID_match
scoreboard players set @s nitSpreadLim 0
function nitk:spread_hell
execute as @e[tag=nitHellSite,tag=nitID_match] at @s run function nitk:special/special_gen_ground
tag @e[tag=nitHellSite,tag=nitID_match] remove nitID_match

###Summons markers for natural structures###
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitEndVault,nitKSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitCrucible,nitKSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitHaroldCage,nitKSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
summon minecraft:marker ~ ~ ~ {Tags:[nitEntity,nitEntityTechnical,nitAlignPuz,nitKSpecialFeature,global.ignore],Invisible:1b,Invulnerable:1b,NoGravity:1b}
scoreboard players operation @e[tag=nitKSpecialFeature,limit=4,sort=nearest] nitID = @s nitID

###Spreads and builds the natural structures for this town###
scoreboard players operation #nitID nitTemp = @s nitID
execute as @e[tag=nitKSpecialFeature,limit=4,sort=nearest] if score @s nitID = #nitID nitTemp run tag @s add nitID_match
scoreboard players set @s nitSpreadLim 0
function nitk:spread_features
execute as @e[tag=nitKSpecialFeature,tag=nitID_match] at @s run function nitk:special/special_gen_ground
scoreboard players set @s nitSpreadLim 0
execute as @e[tag=nitEndVault,tag=nitID_match] at @s run function nitk:special/gen_endvault
execute as @e[tag=nitCrucible,tag=nitID_match] at @s run function nitk:special/gen_crucible
execute as @e[tag=nitHaroldCage,tag=nitID_match] at @s run function nitk:special/gen_haroldcage
execute as @e[tag=nitAlignPuz,tag=nitID_match] at @s run function nitk:special/gen_alignpuz
tag @e[tag=nitKSpecialFeature,tag=nitID_match] remove nitID_match

execute as @s[tag=nitDistanceWarn] run tellraw @s [{"text":"[۩]","color":"green","bold":true},{"text":": ","color":"white","bold":false},{"text":"Beware, some features may spawn very close to your town...","color":"red","bold":false}]
tag @s remove nitDistanceWarn

###Summons the town planner###
execute as @e[tag=nitTownPlanner,limit=1,sort=nearest] at @s unless entity @e[type=villager,tag=nitKTP,distance=..2] run summon villager ~ ~ ~ {VillagerData:{profession:cartographer,level:4,type:plains},Invulnerable:1,PersistenceRequired:1,NoAI:1,CustomName:"\"Town Planner\"",Offers:{Recipes:[{buy:{id:"minecraft:feather",Count:1},sell:{id:"minecraft:written_book",Count:1},maxUses:9999999},{buy:{id:gold_ingot,Count:4},sell:{id:"minecraft:paper",Count:1b,tag:{HideFlags:1,display:{Lore:['{"text":"The final ingredient"}','{"text":"in new town structures."}'],Name:'{"text":"Building Permit"}'},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},maxUses:9999999},{buy:{id:gold_ingot,Count:24},buyB:{id:"minecraft:paper",Count:1b,tag:{HideFlags:1,display:{Lore:['{"text":"The final ingredient"}','{"text":"in new town structures."}'],Name:'{"text":"Building Permit"}'},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},sell:{id:"minecraft:paper",Count:6b,tag:{HideFlags:1,display:{Lore:['{"text":"For preparing sites"}','{"text":"for a unified fortress."}'],Name:'{"text":"Castle Permit"}'},Enchantments:[{lvl:0,id:"minecraft:protection"}]}},maxUses:1}]},Tags:[nitCitizen,nitKTP,global.ignore,nitEntity]}
scoreboard players operation @e[type=villager,tag=nitKTP,limit=1,sort=nearest] nitID = @s nitID
scoreboard players operation @e[tag=nitTownPlanner,limit=1,sort=nearest] nitID = @s nitID
function nitk:debug/update_all

###Starts process for checking if command blocks are enabled###
tag @s[tag=!nitCBEnabled] add nitCBDisabled
setblock ~ 200 ~ repeating_command_block{Command:"function nitk:command_block_check",auto:1b} replace

###Removes forceloaded chunks###
forceload remove ~-100 ~-100 ~100 ~100
tellraw @s [{"text":"[۩]","color":"green","bold":true},{"text":": ","color":"white","bold":false},{"text":"You have successfully settled at this location!","color":"white","bold":false}]